CCTracker = CreateFrame("Frame")

local ignoreSpells = {"Path of Frost","Prowl"}
local DEBUG = false;
local CUR_VER = 1;

if CCTrackerSettings ~= nil and CCTrackerSettings["ver"] > 1 then
	CCTrackerSettings = nil;
end

if CCTrackerSettings == nil then
	CCTrackerSettings = {}
	CCTrackerSettings["ver"] = 1;
	CCTrackerSettings["channel"] = "SELF";
end

CCTracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")

CCTracker:SetScript("OnEvent", function(self, event, ...)
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
        CCTracker:CombatLog(event,...)
    end
end)

function CCTracker:CombatLog(event,...)
    local timestamp, type, someBool, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, something, otherSpellId, otherSpellName = ...
	
	if DEBUG then
		print(timestamp, type, someBool, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, something, otherSpellId, otherSpellName);
	end
	
	for _,ignore in pairs(ignoreSpells) do
		if spellName == ignore then
			return;
		end
	end
	

	if (type=="SPELL_AURA_BROKEN_SPELL")
	then
		if UnitIsFriend("player",destName) == nil then
			CCTracker:Output(sourceName.." broke "..spellName.." on "..destName.." with "..otherSpellName);
		end
	end
	
	--HANDLE hex etc
	
end

function CCTracker:Output(msg)
	if CCTrackerSettings["channel"] == "SELF" then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	else
		SendChatMessage(msg,CCTrackerSettings["channel"],nil,nil);
	end
end

SLASH_CCTRACKER1 = "/cc"
SlashCmdList["CCTRACKER"] = function(msg)
	local cmd = CCTracker:split(msg:lower(), " ");

	if cmd[1] == "test" then
		CCTracker:CombatLog(nil,nil,"SPELL_AURA_BROKEN_SPELL",false,nil,cmd[2],nil,nil,cmd[3],nil,nil,cmd[4],nil,nil,cmd[5]);
	elseif cmd[1] == "debug" then
		if cmd[2] == "on" then
			print("Debuging enabled");
			DEBUG = true;
		else
			print("Debuging disabled");
			DEBUG = false;
		end
	elseif cmd[1] == "channel" then
		if cmd[2] == "" or cmd[2] == "self" then
			cmd[2] = "SELF";
		end
		CCTrackerSettings["channel"] = cmd[2];
	end
end

--http://lua-users.org/wiki/SplitJoin THX!
function CCTracker:split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end